package redis;

import org.apache.commons.lang3.StringUtils;
import redis.clients.jedis.Jedis;
import util.JedisUtil;
import util.Mat2BufImg;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.Timer;


public class ShowFromRedis extends JPanel {
    private String ip = "";
    private BufferedImage mImg;
    private Jedis jedis;
    private String logHead;
    private SimpleDateFormat sdfHH = new SimpleDateFormat("HH:mm:ss");

    public ShowFromRedis(String ip) {
        this.ip = ip;
        logHead = "----------> " + ip + " ";
    }

    public void run() {
        // jedis = new Jedis(JedisUtil.host, 6379);
        Timer timer = new Timer();
        timer.scheduleAtFixedRate(new TimerTask() {
            @Override
            public void run() {
                try {
                    show2();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }, 0, 50);
    }

    private void show2() {
        Jedis jedis = JedisUtil.getJedis();
        String imgHex = jedis.get(ip);
        JedisUtil.close(jedis);
        if (StringUtils.isEmpty(imgHex)) {
            if (new java.util.Date().getSeconds() % 10 == 0) {
                System.out.println(logHead + imgHex);
            }
            return;
        }
        BufferedImage bufferedImage = Mat2BufImg.base64ToBufferedImage(imgHex);
        mImg = bufferedImage;
        repaint();
        // if (new java.util.Date().getSeconds() % 10 == 0) {
        //     System.out.println(logHead + "耗时 " + sdfHH.format(new Date()));
        // }
    }

    @Override
    public void paintComponent(Graphics g) {
        if (mImg != null) {
            g.drawImage(mImg, 0, 0, mImg.getWidth(), mImg.getHeight(), this);
        }
    }
}
