package util;

import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.JedisPoolConfig;

public final class JedisUtil {
    private JedisUtil() {
    }

    private static JedisPool jedisPool;
    private static int maxtotal = 1000;
    private static int maxwaitmillis = 3000;
    // public final static String host = "127.0.0.1";
    private static String host = "192.168.19.135";
    private static int port = 6379;

    /*读取jedis.properties配置文件*/
    static {
        // ResourceBundle rb = ResourceBundle.getBundle("jedis");
        // maxtotal = Integer.parseInt(rb.getString("maxtotal"));
        // maxwaitmillis = Integer.parseInt(rb.getString("maxwaitmillis"));
        // host = rb.getString("host");
        // port = Integer.parseInt(rb.getString("port"));
        JedisPoolConfig jedisPoolConfig = new JedisPoolConfig();
        jedisPoolConfig.setMaxTotal(maxtotal);
        jedisPoolConfig.setMaxWaitMillis(maxwaitmillis);
        jedisPool = new JedisPool(jedisPoolConfig, host, port);
    }

    /*获取jedis*/
    public static Jedis getJedis() {
        return jedisPool.getResource();
    }

    /*关闭Jedis*/
    public static void close(Jedis jedis) {
        if (jedis != null) {
            jedis.close();
        }
    }

    // public static void main(String[] args) {
    //     Jedis jedis = JedisUtil.getJedis();
    //     String s = jedis.get("1");
    //     System.out.println("========" + s);
    // }
}