package util;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.Date;

public class LogHelper {
    private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    private static SimpleDateFormat sdfDD = new SimpleDateFormat("yyyy-MM-dd");
    private static SimpleDateFormat sdfHH = new SimpleDateFormat("HH:mm:ss");
    private static SimpleDateFormat sdfSSS = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");

    private static SimpleDateFormat sdfDDWT = new SimpleDateFormat("yyyyMMdd");
    private static SimpleDateFormat sdfDD_WT = new SimpleDateFormat("yyyy_MM_dd");
    private static SimpleDateFormat sdfHHWT = new SimpleDateFormat("yyyy_MM_dd_HH");
    private static SimpleDateFormat sdfSSSWT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");

    // private static String CPath = "D:/VideoRec2/Log/WinCC/";
    // private static String upJavaPath = "D:/VideoRec2/Log/UpJavaLog/";
    // private static String unJavaPath = "D:/VideoRec2/Log/UnJavaLog/";

    // private static String CPath = "/home/bjlthy/VideoRec/Log/WinCC/";
    // private static String upJavaPath = "/home/bjlthy/VideoRec/Log/UpJavaLog/";
    // private static String unJavaPath = "/home/bjlthy/VideoRec/Log/UnJavaLog/";

    // public static String logPath = "/home/bjlthy/VideoRec/Log";
    public static String logPath = "./SDKtoRedisLog";
    // public static String logPath = Main.logPath;

    static {
        String[] path = new String[]{logPath};
        for (String p1 : path) {
            File f = new File(p1);
            if (!f.exists()) {
                try {
                    f.mkdirs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private static void writeFile(String path, String value) {
        PrintWriter pw = null;
        Writer writer = null;
        try {
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(path, true), "UTF-8"));
            pw = new PrintWriter(writer);
            pw.println("[" + sdfSSS.format(new Date()) + "] " + value);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                pw.flush();
                writer.flush();
                pw.close();
                writer.close();
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
    }


    public static void error(String msg) {
        String filePath = logPath + "/" + sdfDD_WT.format(new Date()) + "_error.txt";
        writeFile(filePath, msg);
    }

    public static void error(String msg, Throwable throwable) {
        String filePath = logPath + "/" + sdfDD_WT.format(new Date()) + "_error.txt";
        writeFile(filePath, msg + "\r\n" + getStackTrace(throwable));
    }

    public static void info(String msg) {
        String filePath = logPath + "/" + sdfDD_WT.format(new Date()) + "_info.txt";
        writeFile(filePath, msg);
    }

    public static void debug(String msg) {
        if (getIsDebug())
            return;
        String filePath = logPath + "/" + sdfHHWT.format(new Date()) + "_debug.txt";
        writeFile(filePath, msg);
    }


    public static String getStackTrace(Throwable throwable) {
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        try {
            throwable.printStackTrace(pw);
            return sw.toString();
        } finally {
            pw.close();
        }
    }

    public static boolean getIsDebug() {
        // Dict isdebug = Dict.dao.getByDataCode(Constant.IsDebug);
        // return "0".equals(isdebug.getDataValue());
        return false;
    }
}
